// $ANTLR 3.3 Nov 30, 2010 12:46:29 org/ow2/mind/preproc/parser/CPL.g 2013-01-15 10:53:57

	package org.ow2.mind.preproc.parser;
	import java.util.regex.Matcher;
	import java.util.regex.Pattern;
	import org.antlr.runtime.ANTLRStringStream;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

public class CPLLexer extends Lexer {
    public static final int EOF=-1;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int T__33=33;
    public static final int T__34=34;
    public static final int T__35=35;
    public static final int T__36=36;
    public static final int T__37=37;
    public static final int T__38=38;
    public static final int METH=4;
    public static final int CONSTRUCTOR=5;
    public static final int DESTRUCTOR=6;
    public static final int GET_MY_INTERFACE=7;
    public static final int BIND_MY_INTERFACE=8;
    public static final int IS_BOUND=9;
    public static final int GET_COLLECTION_SIZE=10;
    public static final int CALL=11;
    public static final int CALL_PTR=12;
    public static final int ATTR=13;
    public static final int PRIVATE=14;
    public static final int METH_PTR=15;
    public static final int VOID=16;
    public static final int STRUCT=17;
    public static final int ID=18;
    public static final int INT=19;
    public static final int LCURLY=20;
    public static final int RCURLY=21;
    public static final int WS=22;
    public static final int LINE_INFO=23;
    public static final int STRING_LITERAL=24;
    public static final int EscapeSequence=25;
    public static final int CHAR_LITERAL=26;
    public static final int OctalEscape=27;
    public static final int HexaEscape=28;
    public static final int HexaDigit=29;
    public static final int ANY=30;


      static final Pattern sourceLinePattern = Pattern
                                                 .compile("\\#\\s*(\\d+)\\s*\"(.*)\"");
      static final int     lineIndex         = 1;
      static final int     fileIndex         = 2;
      
      public String getSourceFileName() {
      	return ((ANTLRStringStream) input).name;
      }

      public void processSourceLine() {
        final Matcher matcher = sourceLinePattern.matcher(input.substring(state.tokenStartCharIndex, getCharIndex()-1));
        if (matcher.matches()) {
          final int line = Integer.parseInt(matcher.group(lineIndex));
          final String file = matcher.group(fileIndex);
          input.setLine(line - 1);
          ((ANTLRStringStream) input).name = file;
        }
      }


    // delegates
    // delegators

    public CPLLexer() {;} 
    public CPLLexer(CharStream input) {
        this(input, new RecognizerSharedState());
    }
    public CPLLexer(CharStream input, RecognizerSharedState state) {
        super(input,state);

    }
    public String getGrammarFileName() { return "org/ow2/mind/preproc/parser/CPL.g"; }

    // $ANTLR start "METH"
    public final void mMETH() throws RecognitionException {
        try {
            int _type = METH;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:31:6: ( 'METH' )
            // org/ow2/mind/preproc/parser/CPL.g:31:8: 'METH'
            {
            match("METH"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "METH"

    // $ANTLR start "CONSTRUCTOR"
    public final void mCONSTRUCTOR() throws RecognitionException {
        try {
            int _type = CONSTRUCTOR;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:32:13: ( 'CONSTRUCTOR' )
            // org/ow2/mind/preproc/parser/CPL.g:32:15: 'CONSTRUCTOR'
            {
            match("CONSTRUCTOR"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "CONSTRUCTOR"

    // $ANTLR start "DESTRUCTOR"
    public final void mDESTRUCTOR() throws RecognitionException {
        try {
            int _type = DESTRUCTOR;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:33:12: ( 'DESTRUCTOR' )
            // org/ow2/mind/preproc/parser/CPL.g:33:14: 'DESTRUCTOR'
            {
            match("DESTRUCTOR"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "DESTRUCTOR"

    // $ANTLR start "GET_MY_INTERFACE"
    public final void mGET_MY_INTERFACE() throws RecognitionException {
        try {
            int _type = GET_MY_INTERFACE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:34:18: ( 'GET_MY_INTERFACE' )
            // org/ow2/mind/preproc/parser/CPL.g:34:20: 'GET_MY_INTERFACE'
            {
            match("GET_MY_INTERFACE"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "GET_MY_INTERFACE"

    // $ANTLR start "BIND_MY_INTERFACE"
    public final void mBIND_MY_INTERFACE() throws RecognitionException {
        try {
            int _type = BIND_MY_INTERFACE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:35:19: ( 'BIND_MY_INTERFACE' )
            // org/ow2/mind/preproc/parser/CPL.g:35:21: 'BIND_MY_INTERFACE'
            {
            match("BIND_MY_INTERFACE"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "BIND_MY_INTERFACE"

    // $ANTLR start "IS_BOUND"
    public final void mIS_BOUND() throws RecognitionException {
        try {
            int _type = IS_BOUND;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:36:10: ( 'IS_BOUND' )
            // org/ow2/mind/preproc/parser/CPL.g:36:12: 'IS_BOUND'
            {
            match("IS_BOUND"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "IS_BOUND"

    // $ANTLR start "GET_COLLECTION_SIZE"
    public final void mGET_COLLECTION_SIZE() throws RecognitionException {
        try {
            int _type = GET_COLLECTION_SIZE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:37:21: ( 'GET_COLLECTION_SIZE' )
            // org/ow2/mind/preproc/parser/CPL.g:37:23: 'GET_COLLECTION_SIZE'
            {
            match("GET_COLLECTION_SIZE"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "GET_COLLECTION_SIZE"

    // $ANTLR start "CALL"
    public final void mCALL() throws RecognitionException {
        try {
            int _type = CALL;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:38:6: ( 'CALL' )
            // org/ow2/mind/preproc/parser/CPL.g:38:8: 'CALL'
            {
            match("CALL"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "CALL"

    // $ANTLR start "CALL_PTR"
    public final void mCALL_PTR() throws RecognitionException {
        try {
            int _type = CALL_PTR;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:39:10: ( 'CALL_PTR' )
            // org/ow2/mind/preproc/parser/CPL.g:39:12: 'CALL_PTR'
            {
            match("CALL_PTR"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "CALL_PTR"

    // $ANTLR start "ATTR"
    public final void mATTR() throws RecognitionException {
        try {
            int _type = ATTR;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:40:6: ( 'ATTR' )
            // org/ow2/mind/preproc/parser/CPL.g:40:8: 'ATTR'
            {
            match("ATTR"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "ATTR"

    // $ANTLR start "PRIVATE"
    public final void mPRIVATE() throws RecognitionException {
        try {
            int _type = PRIVATE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:41:9: ( 'PRIVATE' )
            // org/ow2/mind/preproc/parser/CPL.g:41:11: 'PRIVATE'
            {
            match("PRIVATE"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "PRIVATE"

    // $ANTLR start "METH_PTR"
    public final void mMETH_PTR() throws RecognitionException {
        try {
            int _type = METH_PTR;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:42:10: ( 'METH_PTR' )
            // org/ow2/mind/preproc/parser/CPL.g:42:12: 'METH_PTR'
            {
            match("METH_PTR"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "METH_PTR"

    // $ANTLR start "VOID"
    public final void mVOID() throws RecognitionException {
        try {
            int _type = VOID;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:43:6: ( 'void' )
            // org/ow2/mind/preproc/parser/CPL.g:43:8: 'void'
            {
            match("void"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "VOID"

    // $ANTLR start "STRUCT"
    public final void mSTRUCT() throws RecognitionException {
        try {
            int _type = STRUCT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:44:8: ( 'struct' )
            // org/ow2/mind/preproc/parser/CPL.g:44:10: 'struct'
            {
            match("struct"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "STRUCT"

    // $ANTLR start "T__31"
    public final void mT__31() throws RecognitionException {
        try {
            int _type = T__31;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:45:7: ( '(' )
            // org/ow2/mind/preproc/parser/CPL.g:45:9: '('
            {
            match('('); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__31"

    // $ANTLR start "T__32"
    public final void mT__32() throws RecognitionException {
        try {
            int _type = T__32;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:46:7: ( ')' )
            // org/ow2/mind/preproc/parser/CPL.g:46:9: ')'
            {
            match(')'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__32"

    // $ANTLR start "T__33"
    public final void mT__33() throws RecognitionException {
        try {
            int _type = T__33;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:47:7: ( '[' )
            // org/ow2/mind/preproc/parser/CPL.g:47:9: '['
            {
            match('['); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__33"

    // $ANTLR start "T__34"
    public final void mT__34() throws RecognitionException {
        try {
            int _type = T__34;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:48:7: ( ']' )
            // org/ow2/mind/preproc/parser/CPL.g:48:9: ']'
            {
            match(']'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__34"

    // $ANTLR start "T__35"
    public final void mT__35() throws RecognitionException {
        try {
            int _type = T__35;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:49:7: ( ',' )
            // org/ow2/mind/preproc/parser/CPL.g:49:9: ','
            {
            match(','); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__35"

    // $ANTLR start "T__36"
    public final void mT__36() throws RecognitionException {
        try {
            int _type = T__36;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:50:7: ( '=' )
            // org/ow2/mind/preproc/parser/CPL.g:50:9: '='
            {
            match('='); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__36"

    // $ANTLR start "T__37"
    public final void mT__37() throws RecognitionException {
        try {
            int _type = T__37;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:51:7: ( ';' )
            // org/ow2/mind/preproc/parser/CPL.g:51:9: ';'
            {
            match(';'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__37"

    // $ANTLR start "T__38"
    public final void mT__38() throws RecognitionException {
        try {
            int _type = T__38;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:52:7: ( '.' )
            // org/ow2/mind/preproc/parser/CPL.g:52:9: '.'
            {
            match('.'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__38"

    // $ANTLR start "LINE_INFO"
    public final void mLINE_INFO() throws RecognitionException {
        try {
            int _type = LINE_INFO;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:605:2: ( '#' ( ' ' | '\\t' )* ( 'line' ( ' ' | '\\t' )* )? INT ( ' ' | '\\t' )+ STRING_LITERAL )
            // org/ow2/mind/preproc/parser/CPL.g:605:4: '#' ( ' ' | '\\t' )* ( 'line' ( ' ' | '\\t' )* )? INT ( ' ' | '\\t' )+ STRING_LITERAL
            {
            match('#'); 
            // org/ow2/mind/preproc/parser/CPL.g:605:8: ( ' ' | '\\t' )*
            loop1:
            do {
                int alt1=2;
                switch ( input.LA(1) ) {
                case '\t':
                case ' ':
                    {
                    alt1=1;
                    }
                    break;

                }

                switch (alt1) {
            	case 1 :
            	    // org/ow2/mind/preproc/parser/CPL.g:
            	    {
            	    if ( input.LA(1)=='\t'||input.LA(1)==' ' ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            // org/ow2/mind/preproc/parser/CPL.g:605:22: ( 'line' ( ' ' | '\\t' )* )?
            int alt3=2;
            switch ( input.LA(1) ) {
                case 'l':
                    {
                    alt3=1;
                    }
                    break;
            }

            switch (alt3) {
                case 1 :
                    // org/ow2/mind/preproc/parser/CPL.g:605:23: 'line' ( ' ' | '\\t' )*
                    {
                    match("line"); 

                    // org/ow2/mind/preproc/parser/CPL.g:605:30: ( ' ' | '\\t' )*
                    loop2:
                    do {
                        int alt2=2;
                        switch ( input.LA(1) ) {
                        case '\t':
                        case ' ':
                            {
                            alt2=1;
                            }
                            break;

                        }

                        switch (alt2) {
                    	case 1 :
                    	    // org/ow2/mind/preproc/parser/CPL.g:
                    	    {
                    	    if ( input.LA(1)=='\t'||input.LA(1)==' ' ) {
                    	        input.consume();

                    	    }
                    	    else {
                    	        MismatchedSetException mse = new MismatchedSetException(null,input);
                    	        recover(mse);
                    	        throw mse;}


                    	    }
                    	    break;

                    	default :
                    	    break loop2;
                        }
                    } while (true);


                    }
                    break;

            }

            mINT(); 
            // org/ow2/mind/preproc/parser/CPL.g:605:50: ( ' ' | '\\t' )+
            int cnt4=0;
            loop4:
            do {
                int alt4=2;
                switch ( input.LA(1) ) {
                case '\t':
                case ' ':
                    {
                    alt4=1;
                    }
                    break;

                }

                switch (alt4) {
            	case 1 :
            	    // org/ow2/mind/preproc/parser/CPL.g:
            	    {
            	    if ( input.LA(1)=='\t'||input.LA(1)==' ' ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    if ( cnt4 >= 1 ) break loop4;
                        EarlyExitException eee =
                            new EarlyExitException(4, input);
                        throw eee;
                }
                cnt4++;
            } while (true);

            mSTRING_LITERAL(); 

            		processSourceLine();
            	

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "LINE_INFO"

    // $ANTLR start "STRING_LITERAL"
    public final void mSTRING_LITERAL() throws RecognitionException {
        try {
            int _type = STRING_LITERAL;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:611:5: ( '\"' ( EscapeSequence | ~ ( '\\\\' | '\"' ) )* '\"' )
            // org/ow2/mind/preproc/parser/CPL.g:611:8: '\"' ( EscapeSequence | ~ ( '\\\\' | '\"' ) )* '\"'
            {
            match('\"'); 
            // org/ow2/mind/preproc/parser/CPL.g:611:12: ( EscapeSequence | ~ ( '\\\\' | '\"' ) )*
            loop5:
            do {
                int alt5=3;
                int LA5_0 = input.LA(1);

                if ( (LA5_0=='\\') ) {
                    alt5=1;
                }
                else if ( ((LA5_0>='\u0000' && LA5_0<='!')||(LA5_0>='#' && LA5_0<='[')||(LA5_0>=']' && LA5_0<='\uFFFF')) ) {
                    alt5=2;
                }


                switch (alt5) {
            	case 1 :
            	    // org/ow2/mind/preproc/parser/CPL.g:611:14: EscapeSequence
            	    {
            	    mEscapeSequence(); 

            	    }
            	    break;
            	case 2 :
            	    // org/ow2/mind/preproc/parser/CPL.g:611:31: ~ ( '\\\\' | '\"' )
            	    {
            	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='!')||(input.LA(1)>='#' && input.LA(1)<='[')||(input.LA(1)>=']' && input.LA(1)<='\uFFFF') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);

            match('\"'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "STRING_LITERAL"

    // $ANTLR start "CHAR_LITERAL"
    public final void mCHAR_LITERAL() throws RecognitionException {
        try {
            int _type = CHAR_LITERAL;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:616:5: ( '\\'' ( EscapeSequence | ~ ( '\\'' ) ) '\\'' )
            // org/ow2/mind/preproc/parser/CPL.g:616:8: '\\'' ( EscapeSequence | ~ ( '\\'' ) ) '\\''
            {
            match('\''); 
            // org/ow2/mind/preproc/parser/CPL.g:616:13: ( EscapeSequence | ~ ( '\\'' ) )
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0=='\\') ) {
                switch ( input.LA(2) ) {
                case '\'':
                    {
                    switch ( input.LA(3) ) {
                    case '\'':
                        {
                        alt6=1;
                        }
                        break;
                    default:
                        alt6=2;}

                    }
                    break;
                case '\"':
                case '0':
                case '1':
                case '2':
                case '3':
                case '4':
                case '5':
                case '6':
                case '7':
                case '?':
                case '\\':
                case 'a':
                case 'b':
                case 'f':
                case 'n':
                case 'r':
                case 't':
                case 'v':
                case 'x':
                    {
                    alt6=1;
                    }
                    break;
                default:
                    NoViableAltException nvae =
                        new NoViableAltException("", 6, 1, input);

                    throw nvae;
                }

            }
            else if ( ((LA6_0>='\u0000' && LA6_0<='&')||(LA6_0>='(' && LA6_0<='[')||(LA6_0>=']' && LA6_0<='\uFFFF')) ) {
                alt6=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }
            switch (alt6) {
                case 1 :
                    // org/ow2/mind/preproc/parser/CPL.g:616:15: EscapeSequence
                    {
                    mEscapeSequence(); 

                    }
                    break;
                case 2 :
                    // org/ow2/mind/preproc/parser/CPL.g:616:32: ~ ( '\\'' )
                    {
                    if ( (input.LA(1)>='\u0000' && input.LA(1)<='&')||(input.LA(1)>='(' && input.LA(1)<='\uFFFF') ) {
                        input.consume();

                    }
                    else {
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        recover(mse);
                        throw mse;}


                    }
                    break;

            }

            match('\''); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "CHAR_LITERAL"

    // $ANTLR start "EscapeSequence"
    public final void mEscapeSequence() throws RecognitionException {
        try {
            // org/ow2/mind/preproc/parser/CPL.g:621:5: ( '\\\\' ( 'a' | 'b' | 't' | 'n' | 'f' | 'r' | 'v' | '\"' | '\\'' | '\\\\' | '?' ) | OctalEscape | HexaEscape )
            int alt7=3;
            switch ( input.LA(1) ) {
            case '\\':
                {
                switch ( input.LA(2) ) {
                case '\"':
                case '\'':
                case '?':
                case '\\':
                case 'a':
                case 'b':
                case 'f':
                case 'n':
                case 'r':
                case 't':
                case 'v':
                    {
                    alt7=1;
                    }
                    break;
                case 'x':
                    {
                    alt7=3;
                    }
                    break;
                case '0':
                case '1':
                case '2':
                case '3':
                case '4':
                case '5':
                case '6':
                case '7':
                    {
                    alt7=2;
                    }
                    break;
                default:
                    NoViableAltException nvae =
                        new NoViableAltException("", 7, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }

            switch (alt7) {
                case 1 :
                    // org/ow2/mind/preproc/parser/CPL.g:621:9: '\\\\' ( 'a' | 'b' | 't' | 'n' | 'f' | 'r' | 'v' | '\"' | '\\'' | '\\\\' | '?' )
                    {
                    match('\\'); 
                    if ( input.LA(1)=='\"'||input.LA(1)=='\''||input.LA(1)=='?'||input.LA(1)=='\\'||(input.LA(1)>='a' && input.LA(1)<='b')||input.LA(1)=='f'||input.LA(1)=='n'||input.LA(1)=='r'||input.LA(1)=='t'||input.LA(1)=='v' ) {
                        input.consume();

                    }
                    else {
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        recover(mse);
                        throw mse;}


                    }
                    break;
                case 2 :
                    // org/ow2/mind/preproc/parser/CPL.g:622:9: OctalEscape
                    {
                    mOctalEscape(); 

                    }
                    break;
                case 3 :
                    // org/ow2/mind/preproc/parser/CPL.g:623:9: HexaEscape
                    {
                    mHexaEscape(); 

                    }
                    break;

            }
        }
        finally {
        }
    }
    // $ANTLR end "EscapeSequence"

    // $ANTLR start "OctalEscape"
    public final void mOctalEscape() throws RecognitionException {
        try {
            // org/ow2/mind/preproc/parser/CPL.g:628:5: ( '\\\\' ( '0' .. '3' ) ( '0' .. '7' ) ( '0' .. '7' ) | '\\\\' ( '0' .. '7' ) ( '0' .. '7' ) | '\\\\' ( '0' .. '7' ) )
            int alt8=3;
            switch ( input.LA(1) ) {
            case '\\':
                {
                switch ( input.LA(2) ) {
                case '0':
                case '1':
                case '2':
                case '3':
                    {
                    switch ( input.LA(3) ) {
                    case '0':
                    case '1':
                    case '2':
                    case '3':
                    case '4':
                    case '5':
                    case '6':
                    case '7':
                        {
                        switch ( input.LA(4) ) {
                        case '0':
                        case '1':
                        case '2':
                        case '3':
                        case '4':
                        case '5':
                        case '6':
                        case '7':
                            {
                            alt8=1;
                            }
                            break;
                        default:
                            alt8=2;}

                        }
                        break;
                    default:
                        alt8=3;}

                    }
                    break;
                case '4':
                case '5':
                case '6':
                case '7':
                    {
                    switch ( input.LA(3) ) {
                    case '0':
                    case '1':
                    case '2':
                    case '3':
                    case '4':
                    case '5':
                    case '6':
                    case '7':
                        {
                        alt8=2;
                        }
                        break;
                    default:
                        alt8=3;}

                    }
                    break;
                default:
                    NoViableAltException nvae =
                        new NoViableAltException("", 8, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;
            }

            switch (alt8) {
                case 1 :
                    // org/ow2/mind/preproc/parser/CPL.g:628:9: '\\\\' ( '0' .. '3' ) ( '0' .. '7' ) ( '0' .. '7' )
                    {
                    match('\\'); 
                    // org/ow2/mind/preproc/parser/CPL.g:628:14: ( '0' .. '3' )
                    // org/ow2/mind/preproc/parser/CPL.g:628:15: '0' .. '3'
                    {
                    matchRange('0','3'); 

                    }

                    // org/ow2/mind/preproc/parser/CPL.g:628:25: ( '0' .. '7' )
                    // org/ow2/mind/preproc/parser/CPL.g:628:26: '0' .. '7'
                    {
                    matchRange('0','7'); 

                    }

                    // org/ow2/mind/preproc/parser/CPL.g:628:36: ( '0' .. '7' )
                    // org/ow2/mind/preproc/parser/CPL.g:628:37: '0' .. '7'
                    {
                    matchRange('0','7'); 

                    }


                    }
                    break;
                case 2 :
                    // org/ow2/mind/preproc/parser/CPL.g:629:9: '\\\\' ( '0' .. '7' ) ( '0' .. '7' )
                    {
                    match('\\'); 
                    // org/ow2/mind/preproc/parser/CPL.g:629:14: ( '0' .. '7' )
                    // org/ow2/mind/preproc/parser/CPL.g:629:15: '0' .. '7'
                    {
                    matchRange('0','7'); 

                    }

                    // org/ow2/mind/preproc/parser/CPL.g:629:25: ( '0' .. '7' )
                    // org/ow2/mind/preproc/parser/CPL.g:629:26: '0' .. '7'
                    {
                    matchRange('0','7'); 

                    }


                    }
                    break;
                case 3 :
                    // org/ow2/mind/preproc/parser/CPL.g:630:9: '\\\\' ( '0' .. '7' )
                    {
                    match('\\'); 
                    // org/ow2/mind/preproc/parser/CPL.g:630:14: ( '0' .. '7' )
                    // org/ow2/mind/preproc/parser/CPL.g:630:15: '0' .. '7'
                    {
                    matchRange('0','7'); 

                    }


                    }
                    break;

            }
        }
        finally {
        }
    }
    // $ANTLR end "OctalEscape"

    // $ANTLR start "HexaEscape"
    public final void mHexaEscape() throws RecognitionException {
        try {
            // org/ow2/mind/preproc/parser/CPL.g:636:5: ( '\\\\x' ( HexaDigit )+ )
            // org/ow2/mind/preproc/parser/CPL.g:636:8: '\\\\x' ( HexaDigit )+
            {
            match("\\x"); 

            // org/ow2/mind/preproc/parser/CPL.g:636:14: ( HexaDigit )+
            int cnt9=0;
            loop9:
            do {
                int alt9=2;
                switch ( input.LA(1) ) {
                case '0':
                case '1':
                case '2':
                case '3':
                case '4':
                case '5':
                case '6':
                case '7':
                case '8':
                case '9':
                case 'A':
                case 'B':
                case 'C':
                case 'D':
                case 'E':
                case 'F':
                case 'a':
                case 'b':
                case 'c':
                case 'd':
                case 'e':
                case 'f':
                    {
                    alt9=1;
                    }
                    break;

                }

                switch (alt9) {
            	case 1 :
            	    // org/ow2/mind/preproc/parser/CPL.g:636:14: HexaDigit
            	    {
            	    mHexaDigit(); 

            	    }
            	    break;

            	default :
            	    if ( cnt9 >= 1 ) break loop9;
                        EarlyExitException eee =
                            new EarlyExitException(9, input);
                        throw eee;
                }
                cnt9++;
            } while (true);


            }

        }
        finally {
        }
    }
    // $ANTLR end "HexaEscape"

    // $ANTLR start "HexaDigit"
    public final void mHexaDigit() throws RecognitionException {
        try {
            // org/ow2/mind/preproc/parser/CPL.g:641:2: ( '0' .. '9' | 'a' .. 'f' | 'A' .. 'F' )
            // org/ow2/mind/preproc/parser/CPL.g:
            {
            if ( (input.LA(1)>='0' && input.LA(1)<='9')||(input.LA(1)>='A' && input.LA(1)<='F')||(input.LA(1)>='a' && input.LA(1)<='f') ) {
                input.consume();

            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                recover(mse);
                throw mse;}


            }

        }
        finally {
        }
    }
    // $ANTLR end "HexaDigit"

    // $ANTLR start "ID"
    public final void mID() throws RecognitionException {
        try {
            int _type = ID;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:645:2: ( ( 'a' .. 'z' | 'A' .. 'Z' | '_' ) ( 'a' .. 'z' | 'A' .. 'Z' | '_' | '0' .. '9' )* )
            // org/ow2/mind/preproc/parser/CPL.g:645:4: ( 'a' .. 'z' | 'A' .. 'Z' | '_' ) ( 'a' .. 'z' | 'A' .. 'Z' | '_' | '0' .. '9' )*
            {
            if ( (input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z') ) {
                input.consume();

            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                recover(mse);
                throw mse;}

            // org/ow2/mind/preproc/parser/CPL.g:645:28: ( 'a' .. 'z' | 'A' .. 'Z' | '_' | '0' .. '9' )*
            loop10:
            do {
                int alt10=2;
                switch ( input.LA(1) ) {
                case '0':
                case '1':
                case '2':
                case '3':
                case '4':
                case '5':
                case '6':
                case '7':
                case '8':
                case '9':
                case 'A':
                case 'B':
                case 'C':
                case 'D':
                case 'E':
                case 'F':
                case 'G':
                case 'H':
                case 'I':
                case 'J':
                case 'K':
                case 'L':
                case 'M':
                case 'N':
                case 'O':
                case 'P':
                case 'Q':
                case 'R':
                case 'S':
                case 'T':
                case 'U':
                case 'V':
                case 'W':
                case 'X':
                case 'Y':
                case 'Z':
                case '_':
                case 'a':
                case 'b':
                case 'c':
                case 'd':
                case 'e':
                case 'f':
                case 'g':
                case 'h':
                case 'i':
                case 'j':
                case 'k':
                case 'l':
                case 'm':
                case 'n':
                case 'o':
                case 'p':
                case 'q':
                case 'r':
                case 's':
                case 't':
                case 'u':
                case 'v':
                case 'w':
                case 'x':
                case 'y':
                case 'z':
                    {
                    alt10=1;
                    }
                    break;

                }

                switch (alt10) {
            	case 1 :
            	    // org/ow2/mind/preproc/parser/CPL.g:
            	    {
            	    if ( (input.LA(1)>='0' && input.LA(1)<='9')||(input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    break loop10;
                }
            } while (true);


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "ID"

    // $ANTLR start "WS"
    public final void mWS() throws RecognitionException {
        try {
            int _type = WS;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:647:4: ( ( ( ' ' | '\\t' | '\\r' | '\\n' ) )+ )
            // org/ow2/mind/preproc/parser/CPL.g:647:6: ( ( ' ' | '\\t' | '\\r' | '\\n' ) )+
            {
            // org/ow2/mind/preproc/parser/CPL.g:647:6: ( ( ' ' | '\\t' | '\\r' | '\\n' ) )+
            int cnt11=0;
            loop11:
            do {
                int alt11=2;
                switch ( input.LA(1) ) {
                case '\t':
                case '\n':
                case '\r':
                case ' ':
                    {
                    alt11=1;
                    }
                    break;

                }

                switch (alt11) {
            	case 1 :
            	    // org/ow2/mind/preproc/parser/CPL.g:647:7: ( ' ' | '\\t' | '\\r' | '\\n' )
            	    {
            	    if ( (input.LA(1)>='\t' && input.LA(1)<='\n')||input.LA(1)=='\r'||input.LA(1)==' ' ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    if ( cnt11 >= 1 ) break loop11;
                        EarlyExitException eee =
                            new EarlyExitException(11, input);
                        throw eee;
                }
                cnt11++;
            } while (true);


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "WS"

    // $ANTLR start "INT"
    public final void mINT() throws RecognitionException {
        try {
            int _type = INT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:649:5: ( ( '0' .. '9' )+ )
            // org/ow2/mind/preproc/parser/CPL.g:649:7: ( '0' .. '9' )+
            {
            // org/ow2/mind/preproc/parser/CPL.g:649:7: ( '0' .. '9' )+
            int cnt12=0;
            loop12:
            do {
                int alt12=2;
                switch ( input.LA(1) ) {
                case '0':
                case '1':
                case '2':
                case '3':
                case '4':
                case '5':
                case '6':
                case '7':
                case '8':
                case '9':
                    {
                    alt12=1;
                    }
                    break;

                }

                switch (alt12) {
            	case 1 :
            	    // org/ow2/mind/preproc/parser/CPL.g:649:8: '0' .. '9'
            	    {
            	    matchRange('0','9'); 

            	    }
            	    break;

            	default :
            	    if ( cnt12 >= 1 ) break loop12;
                        EarlyExitException eee =
                            new EarlyExitException(12, input);
                        throw eee;
                }
                cnt12++;
            } while (true);


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "INT"

    // $ANTLR start "LCURLY"
    public final void mLCURLY() throws RecognitionException {
        try {
            int _type = LCURLY;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:651:9: ( '{' )
            // org/ow2/mind/preproc/parser/CPL.g:651:11: '{'
            {
            match('{'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "LCURLY"

    // $ANTLR start "RCURLY"
    public final void mRCURLY() throws RecognitionException {
        try {
            int _type = RCURLY;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:653:9: ( '}' )
            // org/ow2/mind/preproc/parser/CPL.g:653:11: '}'
            {
            match('}'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RCURLY"

    // $ANTLR start "ANY"
    public final void mANY() throws RecognitionException {
        try {
            int _type = ANY;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // org/ow2/mind/preproc/parser/CPL.g:654:7: ( . )
            // org/ow2/mind/preproc/parser/CPL.g:654:10: .
            {
            matchAny(); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "ANY"

    public void mTokens() throws RecognitionException {
        // org/ow2/mind/preproc/parser/CPL.g:1:8: ( METH | CONSTRUCTOR | DESTRUCTOR | GET_MY_INTERFACE | BIND_MY_INTERFACE | IS_BOUND | GET_COLLECTION_SIZE | CALL | CALL_PTR | ATTR | PRIVATE | METH_PTR | VOID | STRUCT | T__31 | T__32 | T__33 | T__34 | T__35 | T__36 | T__37 | T__38 | LINE_INFO | STRING_LITERAL | CHAR_LITERAL | ID | WS | INT | LCURLY | RCURLY | ANY )
        int alt13=31;
        alt13 = dfa13.predict(input);
        switch (alt13) {
            case 1 :
                // org/ow2/mind/preproc/parser/CPL.g:1:10: METH
                {
                mMETH(); 

                }
                break;
            case 2 :
                // org/ow2/mind/preproc/parser/CPL.g:1:15: CONSTRUCTOR
                {
                mCONSTRUCTOR(); 

                }
                break;
            case 3 :
                // org/ow2/mind/preproc/parser/CPL.g:1:27: DESTRUCTOR
                {
                mDESTRUCTOR(); 

                }
                break;
            case 4 :
                // org/ow2/mind/preproc/parser/CPL.g:1:38: GET_MY_INTERFACE
                {
                mGET_MY_INTERFACE(); 

                }
                break;
            case 5 :
                // org/ow2/mind/preproc/parser/CPL.g:1:55: BIND_MY_INTERFACE
                {
                mBIND_MY_INTERFACE(); 

                }
                break;
            case 6 :
                // org/ow2/mind/preproc/parser/CPL.g:1:73: IS_BOUND
                {
                mIS_BOUND(); 

                }
                break;
            case 7 :
                // org/ow2/mind/preproc/parser/CPL.g:1:82: GET_COLLECTION_SIZE
                {
                mGET_COLLECTION_SIZE(); 

                }
                break;
            case 8 :
                // org/ow2/mind/preproc/parser/CPL.g:1:102: CALL
                {
                mCALL(); 

                }
                break;
            case 9 :
                // org/ow2/mind/preproc/parser/CPL.g:1:107: CALL_PTR
                {
                mCALL_PTR(); 

                }
                break;
            case 10 :
                // org/ow2/mind/preproc/parser/CPL.g:1:116: ATTR
                {
                mATTR(); 

                }
                break;
            case 11 :
                // org/ow2/mind/preproc/parser/CPL.g:1:121: PRIVATE
                {
                mPRIVATE(); 

                }
                break;
            case 12 :
                // org/ow2/mind/preproc/parser/CPL.g:1:129: METH_PTR
                {
                mMETH_PTR(); 

                }
                break;
            case 13 :
                // org/ow2/mind/preproc/parser/CPL.g:1:138: VOID
                {
                mVOID(); 

                }
                break;
            case 14 :
                // org/ow2/mind/preproc/parser/CPL.g:1:143: STRUCT
                {
                mSTRUCT(); 

                }
                break;
            case 15 :
                // org/ow2/mind/preproc/parser/CPL.g:1:150: T__31
                {
                mT__31(); 

                }
                break;
            case 16 :
                // org/ow2/mind/preproc/parser/CPL.g:1:156: T__32
                {
                mT__32(); 

                }
                break;
            case 17 :
                // org/ow2/mind/preproc/parser/CPL.g:1:162: T__33
                {
                mT__33(); 

                }
                break;
            case 18 :
                // org/ow2/mind/preproc/parser/CPL.g:1:168: T__34
                {
                mT__34(); 

                }
                break;
            case 19 :
                // org/ow2/mind/preproc/parser/CPL.g:1:174: T__35
                {
                mT__35(); 

                }
                break;
            case 20 :
                // org/ow2/mind/preproc/parser/CPL.g:1:180: T__36
                {
                mT__36(); 

                }
                break;
            case 21 :
                // org/ow2/mind/preproc/parser/CPL.g:1:186: T__37
                {
                mT__37(); 

                }
                break;
            case 22 :
                // org/ow2/mind/preproc/parser/CPL.g:1:192: T__38
                {
                mT__38(); 

                }
                break;
            case 23 :
                // org/ow2/mind/preproc/parser/CPL.g:1:198: LINE_INFO
                {
                mLINE_INFO(); 

                }
                break;
            case 24 :
                // org/ow2/mind/preproc/parser/CPL.g:1:208: STRING_LITERAL
                {
                mSTRING_LITERAL(); 

                }
                break;
            case 25 :
                // org/ow2/mind/preproc/parser/CPL.g:1:223: CHAR_LITERAL
                {
                mCHAR_LITERAL(); 

                }
                break;
            case 26 :
                // org/ow2/mind/preproc/parser/CPL.g:1:236: ID
                {
                mID(); 

                }
                break;
            case 27 :
                // org/ow2/mind/preproc/parser/CPL.g:1:239: WS
                {
                mWS(); 

                }
                break;
            case 28 :
                // org/ow2/mind/preproc/parser/CPL.g:1:242: INT
                {
                mINT(); 

                }
                break;
            case 29 :
                // org/ow2/mind/preproc/parser/CPL.g:1:246: LCURLY
                {
                mLCURLY(); 

                }
                break;
            case 30 :
                // org/ow2/mind/preproc/parser/CPL.g:1:253: RCURLY
                {
                mRCURLY(); 

                }
                break;
            case 31 :
                // org/ow2/mind/preproc/parser/CPL.g:1:260: ANY
                {
                mANY(); 

                }
                break;

        }

    }


    protected DFA13 dfa13 = new DFA13(this);
    static final String DFA13_eotS =
        "\1\uffff\12\35\10\uffff\3\33\6\uffff\1\35\1\uffff\12\35\17\uffff"+
        "\13\35\1\116\1\35\1\121\4\35\1\127\1\35\1\131\2\35\1\uffff\2\35"+
        "\1\uffff\5\35\1\uffff\1\35\1\uffff\12\35\1\156\10\35\1\167\1\uffff"+
        "\1\170\1\35\1\172\4\35\1\177\2\uffff\1\35\1\uffff\4\35\1\uffff\1"+
        "\35\1\u0086\3\35\1\u008a\1\uffff\3\35\1\uffff\14\35\1\u009a\2\35"+
        "\1\uffff\1\35\1\u009e\1\35\1\uffff\1\u00a0\1\uffff";
    static final String DFA13_eofS =
        "\u00a1\uffff";
    static final String DFA13_minS =
        "\1\0\1\105\1\101\2\105\1\111\1\123\1\124\1\122\1\157\1\164\10\uffff"+
        "\1\11\2\0\6\uffff\1\124\1\uffff\1\116\1\114\1\123\1\124\1\116\1"+
        "\137\1\124\1\111\1\151\1\162\17\uffff\1\110\1\123\1\114\1\124\1"+
        "\137\1\104\1\102\1\122\1\126\1\144\1\165\1\60\1\124\1\60\1\122\1"+
        "\103\1\137\1\117\1\60\1\101\1\60\1\143\1\120\1\uffff\1\122\1\120"+
        "\1\uffff\1\125\1\131\1\117\1\115\1\125\1\uffff\1\124\1\uffff\1\164"+
        "\1\124\1\125\1\124\1\103\1\137\1\114\1\131\1\116\1\105\1\60\1\122"+
        "\1\103\1\122\1\124\1\111\1\114\1\137\1\104\1\60\1\uffff\1\60\1\124"+
        "\1\60\1\117\1\116\1\105\1\111\1\60\2\uffff\1\117\1\uffff\1\122\1"+
        "\124\1\103\1\116\1\uffff\1\122\1\60\1\105\2\124\1\60\1\uffff\1\122"+
        "\1\111\1\105\1\uffff\1\106\1\117\1\122\1\101\1\116\1\106\1\103\1"+
        "\137\1\101\1\105\1\123\1\103\1\60\1\111\1\105\1\uffff\1\132\1\60"+
        "\1\105\1\uffff\1\60\1\uffff";
    static final String DFA13_maxS =
        "\1\uffff\1\105\1\117\2\105\1\111\1\123\1\124\1\122\1\157\1\164\10"+
        "\uffff\1\154\2\uffff\6\uffff\1\124\1\uffff\1\116\1\114\1\123\1\124"+
        "\1\116\1\137\1\124\1\111\1\151\1\162\17\uffff\1\110\1\123\1\114"+
        "\1\124\1\137\1\104\1\102\1\122\1\126\1\144\1\165\1\172\1\124\1\172"+
        "\1\122\1\115\1\137\1\117\1\172\1\101\1\172\1\143\1\120\1\uffff\1"+
        "\122\1\120\1\uffff\1\125\1\131\1\117\1\115\1\125\1\uffff\1\124\1"+
        "\uffff\1\164\1\124\1\125\1\124\1\103\1\137\1\114\1\131\1\116\1\105"+
        "\1\172\1\122\1\103\1\122\1\124\1\111\1\114\1\137\1\104\1\172\1\uffff"+
        "\1\172\1\124\1\172\1\117\1\116\1\105\1\111\1\172\2\uffff\1\117\1"+
        "\uffff\1\122\1\124\1\103\1\116\1\uffff\1\122\1\172\1\105\2\124\1"+
        "\172\1\uffff\1\122\1\111\1\105\1\uffff\1\106\1\117\1\122\1\101\1"+
        "\116\1\106\1\103\1\137\1\101\1\105\1\123\1\103\1\172\1\111\1\105"+
        "\1\uffff\1\132\1\172\1\105\1\uffff\1\172\1\uffff";
    static final String DFA13_acceptS =
        "\13\uffff\1\17\1\20\1\21\1\22\1\23\1\24\1\25\1\26\3\uffff\1\32\1"+
        "\33\1\34\1\35\1\36\1\37\1\uffff\1\32\12\uffff\1\17\1\20\1\21\1\22"+
        "\1\23\1\24\1\25\1\26\1\27\1\30\1\31\1\33\1\34\1\35\1\36\27\uffff"+
        "\1\1\2\uffff\1\10\5\uffff\1\12\1\uffff\1\15\24\uffff\1\16\10\uffff"+
        "\1\13\1\14\1\uffff\1\11\4\uffff\1\6\6\uffff\1\3\3\uffff\1\2\17\uffff"+
        "\1\4\3\uffff\1\5\1\uffff\1\7";
    static final String DFA13_specialS =
        "\1\1\23\uffff\1\2\1\0\u008b\uffff}>";
    static final String[] DFA13_transitionS = {
            "\11\33\2\27\2\33\1\27\22\33\1\27\1\33\1\24\1\23\3\33\1\25\1"+
            "\13\1\14\2\33\1\17\1\33\1\22\1\33\12\30\1\33\1\21\1\33\1\20"+
            "\3\33\1\7\1\5\1\2\1\3\2\26\1\4\1\26\1\6\3\26\1\1\2\26\1\10\12"+
            "\26\1\15\1\33\1\16\1\33\1\26\1\33\22\26\1\12\2\26\1\11\4\26"+
            "\1\31\1\33\1\32\uff82\33",
            "\1\34",
            "\1\37\15\uffff\1\36",
            "\1\40",
            "\1\41",
            "\1\42",
            "\1\43",
            "\1\44",
            "\1\45",
            "\1\46",
            "\1\47",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\60\26\uffff\1\60\17\uffff\12\60\62\uffff\1\60",
            "\0\61",
            "\47\62\1\uffff\uffd8\62",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\67",
            "",
            "\1\70",
            "\1\71",
            "\1\72",
            "\1\73",
            "\1\74",
            "\1\75",
            "\1\76",
            "\1\77",
            "\1\100",
            "\1\101",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\102",
            "\1\103",
            "\1\104",
            "\1\105",
            "\1\106",
            "\1\107",
            "\1\110",
            "\1\111",
            "\1\112",
            "\1\113",
            "\1\114",
            "\12\35\7\uffff\32\35\4\uffff\1\115\1\uffff\32\35",
            "\1\117",
            "\12\35\7\uffff\32\35\4\uffff\1\120\1\uffff\32\35",
            "\1\122",
            "\1\124\11\uffff\1\123",
            "\1\125",
            "\1\126",
            "\12\35\7\uffff\32\35\4\uffff\1\35\1\uffff\32\35",
            "\1\130",
            "\12\35\7\uffff\32\35\4\uffff\1\35\1\uffff\32\35",
            "\1\132",
            "\1\133",
            "",
            "\1\134",
            "\1\135",
            "",
            "\1\136",
            "\1\137",
            "\1\140",
            "\1\141",
            "\1\142",
            "",
            "\1\143",
            "",
            "\1\144",
            "\1\145",
            "\1\146",
            "\1\147",
            "\1\150",
            "\1\151",
            "\1\152",
            "\1\153",
            "\1\154",
            "\1\155",
            "\12\35\7\uffff\32\35\4\uffff\1\35\1\uffff\32\35",
            "\1\157",
            "\1\160",
            "\1\161",
            "\1\162",
            "\1\163",
            "\1\164",
            "\1\165",
            "\1\166",
            "\12\35\7\uffff\32\35\4\uffff\1\35\1\uffff\32\35",
            "",
            "\12\35\7\uffff\32\35\4\uffff\1\35\1\uffff\32\35",
            "\1\171",
            "\12\35\7\uffff\32\35\4\uffff\1\35\1\uffff\32\35",
            "\1\173",
            "\1\174",
            "\1\175",
            "\1\176",
            "\12\35\7\uffff\32\35\4\uffff\1\35\1\uffff\32\35",
            "",
            "",
            "\1\u0080",
            "",
            "\1\u0081",
            "\1\u0082",
            "\1\u0083",
            "\1\u0084",
            "",
            "\1\u0085",
            "\12\35\7\uffff\32\35\4\uffff\1\35\1\uffff\32\35",
            "\1\u0087",
            "\1\u0088",
            "\1\u0089",
            "\12\35\7\uffff\32\35\4\uffff\1\35\1\uffff\32\35",
            "",
            "\1\u008b",
            "\1\u008c",
            "\1\u008d",
            "",
            "\1\u008e",
            "\1\u008f",
            "\1\u0090",
            "\1\u0091",
            "\1\u0092",
            "\1\u0093",
            "\1\u0094",
            "\1\u0095",
            "\1\u0096",
            "\1\u0097",
            "\1\u0098",
            "\1\u0099",
            "\12\35\7\uffff\32\35\4\uffff\1\35\1\uffff\32\35",
            "\1\u009b",
            "\1\u009c",
            "",
            "\1\u009d",
            "\12\35\7\uffff\32\35\4\uffff\1\35\1\uffff\32\35",
            "\1\u009f",
            "",
            "\12\35\7\uffff\32\35\4\uffff\1\35\1\uffff\32\35",
            ""
    };

    static final short[] DFA13_eot = DFA.unpackEncodedString(DFA13_eotS);
    static final short[] DFA13_eof = DFA.unpackEncodedString(DFA13_eofS);
    static final char[] DFA13_min = DFA.unpackEncodedStringToUnsignedChars(DFA13_minS);
    static final char[] DFA13_max = DFA.unpackEncodedStringToUnsignedChars(DFA13_maxS);
    static final short[] DFA13_accept = DFA.unpackEncodedString(DFA13_acceptS);
    static final short[] DFA13_special = DFA.unpackEncodedString(DFA13_specialS);
    static final short[][] DFA13_transition;

    static {
        int numStates = DFA13_transitionS.length;
        DFA13_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA13_transition[i] = DFA.unpackEncodedString(DFA13_transitionS[i]);
        }
    }

    class DFA13 extends DFA {

        public DFA13(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 13;
            this.eot = DFA13_eot;
            this.eof = DFA13_eof;
            this.min = DFA13_min;
            this.max = DFA13_max;
            this.accept = DFA13_accept;
            this.special = DFA13_special;
            this.transition = DFA13_transition;
        }
        public String getDescription() {
            return "1:1: Tokens : ( METH | CONSTRUCTOR | DESTRUCTOR | GET_MY_INTERFACE | BIND_MY_INTERFACE | IS_BOUND | GET_COLLECTION_SIZE | CALL | CALL_PTR | ATTR | PRIVATE | METH_PTR | VOID | STRUCT | T__31 | T__32 | T__33 | T__34 | T__35 | T__36 | T__37 | T__38 | LINE_INFO | STRING_LITERAL | CHAR_LITERAL | ID | WS | INT | LCURLY | RCURLY | ANY );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            IntStream input = _input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA13_21 = input.LA(1);

                        s = -1;
                        if ( ((LA13_21>='\u0000' && LA13_21<='&')||(LA13_21>='(' && LA13_21<='\uFFFF')) ) {s = 50;}

                        else s = 27;

                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA13_0 = input.LA(1);

                        s = -1;
                        if ( (LA13_0=='M') ) {s = 1;}

                        else if ( (LA13_0=='C') ) {s = 2;}

                        else if ( (LA13_0=='D') ) {s = 3;}

                        else if ( (LA13_0=='G') ) {s = 4;}

                        else if ( (LA13_0=='B') ) {s = 5;}

                        else if ( (LA13_0=='I') ) {s = 6;}

                        else if ( (LA13_0=='A') ) {s = 7;}

                        else if ( (LA13_0=='P') ) {s = 8;}

                        else if ( (LA13_0=='v') ) {s = 9;}

                        else if ( (LA13_0=='s') ) {s = 10;}

                        else if ( (LA13_0=='(') ) {s = 11;}

                        else if ( (LA13_0==')') ) {s = 12;}

                        else if ( (LA13_0=='[') ) {s = 13;}

                        else if ( (LA13_0==']') ) {s = 14;}

                        else if ( (LA13_0==',') ) {s = 15;}

                        else if ( (LA13_0=='=') ) {s = 16;}

                        else if ( (LA13_0==';') ) {s = 17;}

                        else if ( (LA13_0=='.') ) {s = 18;}

                        else if ( (LA13_0=='#') ) {s = 19;}

                        else if ( (LA13_0=='\"') ) {s = 20;}

                        else if ( (LA13_0=='\'') ) {s = 21;}

                        else if ( ((LA13_0>='E' && LA13_0<='F')||LA13_0=='H'||(LA13_0>='J' && LA13_0<='L')||(LA13_0>='N' && LA13_0<='O')||(LA13_0>='Q' && LA13_0<='Z')||LA13_0=='_'||(LA13_0>='a' && LA13_0<='r')||(LA13_0>='t' && LA13_0<='u')||(LA13_0>='w' && LA13_0<='z')) ) {s = 22;}

                        else if ( ((LA13_0>='\t' && LA13_0<='\n')||LA13_0=='\r'||LA13_0==' ') ) {s = 23;}

                        else if ( ((LA13_0>='0' && LA13_0<='9')) ) {s = 24;}

                        else if ( (LA13_0=='{') ) {s = 25;}

                        else if ( (LA13_0=='}') ) {s = 26;}

                        else if ( ((LA13_0>='\u0000' && LA13_0<='\b')||(LA13_0>='\u000B' && LA13_0<='\f')||(LA13_0>='\u000E' && LA13_0<='\u001F')||LA13_0=='!'||(LA13_0>='$' && LA13_0<='&')||(LA13_0>='*' && LA13_0<='+')||LA13_0=='-'||LA13_0=='/'||LA13_0==':'||LA13_0=='<'||(LA13_0>='>' && LA13_0<='@')||LA13_0=='\\'||LA13_0=='^'||LA13_0=='`'||LA13_0=='|'||(LA13_0>='~' && LA13_0<='\uFFFF')) ) {s = 27;}

                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA13_20 = input.LA(1);

                        s = -1;
                        if ( ((LA13_20>='\u0000' && LA13_20<='\uFFFF')) ) {s = 49;}

                        else s = 27;

                        if ( s>=0 ) return s;
                        break;
            }
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 13, _s, input);
            error(nvae);
            throw nvae;
        }
    }
 

}